//IO, based on IO example
txtIo io = new txtIo();
String[] story = {""};
String raw;
int i=0; // Counter for sentence

int windowWidth = 800;
int windowHeight= 600;
int newLineY = 40; // Position of first line

//RE, based on IO example
String match;
String[][] matchAll;
String[] pat = {".*?","[A-Z].*?\\.",};

int blinkerColor = 240;

void setup(){
  size(windowWidth, windowHeight);
  frameRate(1);
  PFont font;
  font = loadFont("Serif-30.vlw");
  textFont(font);
  fill(#eeeeee, 240);
  background(50);
  
  
  // Make an array of all the sentences
  raw = io.loadRaw("data.txt");
  raw = raw.toUpperCase();
  story = split (raw, ".");
 
}

void draw(){
    
    fill(50,50,50,130); // Draw a new "background" over everything else
    rect(0, 0, 2000, 2000);
    
    //Show a blinker to indicate keyboard input
    fill(blinkerColor);
    if(blinkerColor == 240)
    {
      blinkerColor = 50;
    }
    else
    {
      blinkerColor = 240;
    }
    rect(15, 550, 5, 40);
    
    fill(#eeeeee, 240);
    
    // Show the new line of text
    text(story[i].trim(), 30, newLineY, 700, 90);
    i++; // Move to the next line
    
    // Loop to beginning if need be
    if (story.length-1 < i)
      { i = 0; }
    
    // Vertically reposition the new line
    newLineY += 30;
    if(newLineY > (windowHeight - 120))
      { newLineY = 30; }
    
}

// Taken from IO example to read a TXT file
class txtIo{
  BufferedReader reader;
  //I
  String loadRaw(String filePath){
    reader = createReader(filePath);   
    String line = "";
    String lines = "";  
    while(line != null) {
      try {
        line = reader.readLine();
        lines+=line;
      } catch (IOException e) {
        e.printStackTrace();
      } 
    }
    return lines;
  }
  //I
   String[] loadLines(String filePath){
   return loadStrings(filePath);
  }
  //O
  void saveLines(String filePath, String[] lines){
    saveStrings(filePath, lines);
  } 
}

// When a key is pressed, get that key and try to show a new sentence that starts with it
void keyPressed() {
  String typedKey = ("" + key).toUpperCase();
  if(typedKey.matches("[A-Za-z]")) // Only if typing a letter
  {
    String firstLetter = "";
    String sentence = "";
    int checkCount = 0; // Make sure you don't check too many sentences
    do
    {
      i = int(random(story.length-1)); // Pick a random line from the story
      sentence = story[i].trim();
      
      // Make sure it's checking a long enough string or it'll crash
      if(sentence.length() > 2)
      {
        firstLetter = "" + sentence.charAt(0);
      }
      else
      {
        firstLetter = "ETHAN!";
      }
      
      // Keep track of how many sentences have been checked for similarity
      checkCount++;
      
    } while(!(firstLetter.equals(typedKey)) && checkCount < 80);
    
    text(typedKey, 25, 580); // Show typed letter near blinker
    
    newLineY = (int)random(40, 440); // Randomize the position of the new text
  }
}
